<?php
/**
 * fw Tags Joomulus Module for Joomla! 1.5
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// define directory separator short constant
if (!defined('DS')) {
	define('DS', DIRECTORY_SEPARATOR);
}

// include functions only once
require_once ('components'.DS.'com_tag'.DS.'helper'.DS.'helper.php');

class fwTagsJoomulusHelper
{

	var $options;
	
	/** Constructor
	 *
	 *  Gets module params
	 */      	 
	function fwTagsJoomulusHelper($option)
  {
		$this->options = $option;
	}

  /** Get Tags list from Tags extension
   *
   */     
	function getList()
	{
		global $mainframe;
		
		$db	=& JFactory::getDBO();
		$maxcount = $this->options['count'];
		
		//$query = 'select count(*) as ct, cid, weight, name from #__tag_term_content as tc inner join #__tag_term as t on t.id=tc.tid  group by(tid)';
		$query = 'select count(*) as ct, weight, name from #__tag_term_content as tc inner join #__tag_term as t on t.id=tc.tid  group by(tid)';
		$mostread = 0;
		switch ($this->options['criteria']) {
      case '_latest':
		    $query .= ' order by created DESC';
		    break;
		  case '_mostpopular':
		    $query .= ' order by hits DESC';
		    break;
		  default:
		    $mostread = 1;
    }
		$db->setQuery($query, 0, $maxcount);
		$rows = $db->loadObjectList();

		if(isset($rows)&&!empty($rows)){
			
			//usort($rows, array('JoomlaTagsHelper','tag_popularasort'));
			$count = count($rows);
			for ($index = 0; $index < $count; $index++) {
				$row = &$rows[$index];
				$row->link=JRoute::_('index.php?option=com_tag&task=tag&tag='.JoomlaTagsHelper::urlTagname($row->name));
				//$row->link=JRoute::_('index.php?option=com_content&view=article&id='.$row->cid);
				if ($mostread) {
          $row->size = 10 + ($row->weight * 0.5);
        } else {
          $row->size = 10 + ($row->ct * 0.5);
        }
				$row->name = JoomlaTagsHelper::ucwords($row->name);
			}
			//usort($rows, array('JoomlaTagsHelper','tag_alphasort'));
		}		
		return $rows;
	}

  /** Build tagwords from Tags list
   *
   */     
	function tagwords () {
    $tags = $this->getList();
		$tagcloud ='';
		$count = count($tags);
		for ($index = 0; $index < $count; $index++) {
      $tagcloud .= "<a href='".$tags[$index]->link."' target='".$this->options['target']."' style='font-size:".$tags[$index]->size."'>".$tags[$index]->name."</a>\n ";
    }
		if (trim($tagcloud) == '') {
			$tagcloud = "<a href='".JURI::base()."' target='".$this->options['target']."' style='font-size:20'>NOTHINGFOUND</a>\n ";
		}
		$html = '<tags>'. $tagcloud . '</tags>';
		return $html;
	}
	
	function altdiv ($tags) { // build alternative div content (only contents inside the div!!!)
		return '<p>'.$tags.'</p>';
	}
	
	function flashvars($tags) { // build specific flashvars for this mode
		$tagcloud = 'mode: "tags", ';
		$tagcloud .= 'tagcloud: "'. urlencode($tags) . '" ';
		return $tagcloud;	
	}

  /** Build flash HTML with SWFobject
   *
   */      
	function render($tags, $altdiv, $subflashvars ) {
		global $mainframe;
		global $modCount;
		$name = 'fwTagsJoomulus';
		$divname = $name.$modCount;
		$classvalue = $name.'_'.$this->options['moduleclass_sfx'];
		$flashtag = '';
		
		// Gets SWF based on user params
		if ($this->options['swfobject']!='0') {
			$mainframe->addCustomHeadTag("\n<script type=\"text/javascript\" src=\"".JURI::base()."modules/mod_fwtagsjoomulus/assets/swfobject.js\" ></script>\n");
		}
		$movie = JURI::base().'modules/mod_fwtagsjoomulus/assets/tagcloud'.$this->options['language'].'.swf';

		// Load  expressinstall.swf file,  ideally this would be  module parameter .. 
		$expressinstall = '"'.JURI::base().'modules/mod_fwtagsjoomulus/assets/expressinstall.swf"';
	
		// Add alternate div contents
		$html = '<div class="'.$classvalue.'" id="'.$divname.'">' . $altdiv . '</div>';
		
		$flashtag .= '<script type="text/javascript" >';
		$flashtag .= '	var flashvars = {';
		if ( $this->options['distr'] == '1' ) {
      $flashtag .= 'distr: "true",'; } else { $flashtag .= 'distr: "false",';
    }
		$flashtag .= 'tcolor: "0x'.$this->options['tcolor'].'",';
		if ( $this->options['tcolor2'] == "" ) {
      $flashtag .= 'tcolor2: "0x'.$this->options['tcolor'].'",';
    } else {
      $flashtag .= 'tcolor2: "0x'.$this->options['tcolor2'].'",';
    }
		$flashtag .= 'hicolor: "0x'.$this->options['hicolor'].'",';
		$flashtag .= 'tspeed: "'.$this->options['speed'].'",';
		$flashtag .= 'scale_x: "'.$this->options['scale_x'].'",';
		$flashtag .= 'scale_y: "'.$this->options['scale_y'].'",';
		
		// Add mode-specific flashvars and close flashvars section
		$flashtag .= $subflashvars . '}; ';
		
		$flashtag .= '	var params = {';
		if ( $this->options['trans'] == '1' ) {
      $flashtag .= 'wmode: "transparent",';
    }
		$flashtag .= 'bgcolor: "'.$this->options['bgcolor'].'",';
		$flashtag .= 'allowscriptaccess: "sameDomain"';
		$flashtag .= '};';
		
		$flashtag .= ' var attributes = {};';
		$flashtag .= ' var rnumber = Math.floor(Math.random()*9999999);'; // force loading of movie to fix IE weirdness
		$flashtag .= ' swfobject.embedSWF("'.$movie.'?r="+rnumber, "'.$divname.'", "'.$this->options['width'].'", "'.$this->options['height'].'", "9.0.115",'.$expressinstall.', flashvars, params, attributes);';
		$flashtag .= '</script>';
		
		// Adds javascript to head page for loading joomulus SWF
		$mainframe->addCustomHeadTag("\n". $flashtag."\n");
		
		return $html;
	}
}
?>
